# -*- coding: UTF-8 -*-
# -Cleaned and Checked on 26-09-20.

import re
import urllib
import urlparse

from Cyberscrapers.modules import cleantitle
from Cyberscrapers.modules import client
from Cyberscrapers.modules import debrid
from Cyberscrapers.modules import source_utils
from Cyberscrapers.modules import cfscrape


class source:
	def __init__(self):
		self.priority = 1
		self.language = ['en']
		self.domains = ['www.doublr.org']
		self.base_link = 'https://www.doublr.org'
		self.search_link = '/search?q=%s'


	def movie(self, imdb, title, localtitle, aliases, year):
		try:
			url = {'imdb': imdb, 'title': title, 'year': year}
			url = urllib.urlencode(url)
			return url
		except:
			return


	def tvshow(self, imdb, tvdb, tvshowtitle, localtvshowtitle, aliases, year):
		try:
			url = {'imdb': imdb, 'tvdb': tvdb, 'tvshowtitle': tvshowtitle, 'year': year}
			url = urllib.urlencode(url)
			return url
		except:
			return


	def episode(self, url, imdb, tvdb, title, premiered, season, episode):
		try:
			if url is None:
				return
			url = urlparse.parse_qs(url)
			url = dict([(i, url[i][0]) if url[i] else (i, '') for i in url])
			url['title'], url['premiered'], url['season'], url['episode'] = title, premiered, season, episode
			url = urllib.urlencode(url)
			return url
		except:
			return


	def sources(self, url, hostDict, hostprDict):
		sources = []
		try:
			if url is None:
				return sources

			if debrid.status() is False:
				return sources

			data = urlparse.parse_qs(url)
			data = dict([(i, data[i][0]) if data[i] else (i, '') for i in data])

			title = data['tvshowtitle'] if 'tvshowtitle' in data else data['title']
			title = title.replace('&', 'and').replace('Special Victims Unit', 'SVU')

			hdlr = 'S%02dE%02d' % (int(data['season']), int(data['episode'])) if 'tvshowtitle' in data else data['year']

			query = '%s %s' % (title, hdlr)
			query = re.sub('(\\\|/| -|:|;|\*|\?|"|\'|<|>|\|)', '', query)

			url = self.search_link % urllib.quote_plus(query)
			url = urlparse.urljoin(self.base_link, url)
			# log_utils.log('url = %s' % url, log_utils.LOGDEBUG)

			r = client.request(url)
			posts = client.parseDOM(r, 'tr')

		except:
			source_utils.scraper_error('DOUBLR')
			return sources

		for post in posts:
			try:
				links = re.findall('<a href="(/torrent/.+?)">(.+?)<', post, re.DOTALL)

				for link, ref in links:
					link = urlparse.urljoin(self.base_link, link)
					link = client.request(link)
					link = re.findall('a class=".+?" rel=".+?" href="(magnet:.+?)"', link, re.DOTALL)

					for url in link:
						url = url.split('&tr')[0]
						url = urllib.unquote_plus(urllib.unquote_plus(url)).split('&tr')[0].replace(' ', '.')
						if url in str(sources):
							continue

						name = url.split('&dn=')[1]
						if source_utils.remove_lang(name):
							continue

						if name.startswith('www'):
							try:
								name = re.sub(r'www(.*?)\W{2,10}', '', name)
							except:
								name = name.split('-.', 1)[1].lstrip()

						t = name.split(hdlr)[0].replace(data['year'], '').replace('(', '').replace(')', '').replace('&', 'and').replace('.US.', '.').replace('.us.', '.')
						if cleantitle.get(t) != cleantitle.get(title):
							continue

						if hdlr not in name:
							continue

						quality, info = source_utils.get_release_quality(name, url)

						try:
							size = re.findall('((?:\d+\,\d+\.\d+|\d+\.\d+|\d+\,\d+|\d+)\s*(?:GiB|MiB|GB|MB))', post)[0]
							dsize, isize = source_utils._size(size)
							info.insert(0, isize)
						except:
							dsize = 0
							pass

						info = ' | '.join(info)

						sources.append({'source': 'torrent', 'quality': quality, 'language': 'en', 'url': url,
													'info': info, 'direct': False, 'debridonly': True, 'size': dsize})

			except:
				source_utils.scraper_error('DOUBLR')
				return sources

		return sources


	def resolve(self, url):
		return url